<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from transform.texi on 28 April 1999 -->

<TITLE>The TRANSFORM Library - Unimodular Transforms</TITLE>
<link href="transform_4.html" rel=Next>
<link href="transform_2.html" rel=Previous>
<link href="transform_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_2.html">previous</A>, <A HREF="transform_4.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC3" HREF="transform_toc.html#TOC3">Unimodular Transforms</A></H2>

<P>
A unimodular transformation is a transformation of the loops' iteration 
space that can be represented as a unimodular matrix.
A unimodular matrix is a square, integer matrix where the absolute value of 
the determinant is 1.

</P>
<P>
The method <CODE>unimodular_transform</CODE> in the <CODE>loop_transform</CODE> class 
is used to generate unimodular
loop transformations.  This method takes a unimodular <CODE>integer_matrix</CODE>
as a parameter.
It returns a boolean to indicate if the transformation was successful.
If a non-skew unimodular transformation (e.g. interchange) is specified,
then the loops must be perfectly nested.

</P>
<P>
The routine transforms the bounds and body of the code, but the index names are
left in place.  For example, given the code:

</P>

<PRE>
for (i = 0; i &#60;= N; i++) {
    for (j = i+1; j &#60;= N; j++) {
        A[i][j] = ...;
    }
}
</PRE>

<P>
If we apply loop interchange, specified by the following unimodular matrix:

<PRE>
[ 0 1 ]
[ 1 0 ]
</PRE>

<P>
The resulting code is:

<PRE>
for (i = 0; i &#60;= N; i++) {
    for (j = 1; j &#60;= i-1; j++) {
        A[j][i] = ...;
    }
}
</PRE>

<P>
Note that the position of <CODE>tree_fors</CODE> nodes in SUIF code 
is <EM>not</EM> changed.  
In particular, any annotations attached to a <CODE>tree_for</CODE> remain with
that <CODE>tree_for</CODE> after the transformation.

</P>
<P>
For another example, given the following code:

<PRE>
for (i = 0; i &#60;= M; i++) {
    for (j = 0; j &#60;= N; j++) {
        A[j+1] = .333 * (A[j] + A[j+1] + A[j+2]);
    }
}
</PRE>

<P>
If we skew the loops using the unimodular matrix:

<PRE>
[ 1 0 ]
[ 1 1 ]
</PRE>

<P>
The resulting code is:

<PRE>
for (i = 0; i &#60;= M; i++) {
    for (j = i; j &#60;= N+i; j++) {
        A[j-i+1] = .333 * (A[j-i] + A[j-i+1] + A[j-i+2]);
    }
}
</PRE>

<P><HR><P>
<p>Go to the <A HREF="transform_1.html">first</A>, <A HREF="transform_2.html">previous</A>, <A HREF="transform_4.html">next</A>, <A HREF="transform_8.html">last</A> section, <A HREF="transform_toc.html">table of contents</A>.
</BODY>
</HTML>
